/*
 * File: Twins.cs
 * Date: 11 aug 2012
 * Time: 13:03:42
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     15 ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
 *     27 ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 )
 *     54 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In )
 *     56 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
 *     84 ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
 *     94 ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
 *    105 ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port )
 * Triggers:
 *      1 void IOracle___Ask( String sAsk )
 *      2 void ICbTwin___CbQuestion( String sQuestion )
 *      3 void ICbTwin___CbAnswer( String sAnswer )
 *      4 void ICbOracle___CbReply( String sReply )
 * Natives:
 *     38 ( TwinMockFsm >> CompoundState >> Idle ) ->
 *        ( TwinMockFsm >> CompoundState >> Asking )
 *        pp_Out2->CbQuestion(\"My question?\");
 *     46 ( TwinMockFsm >> CompoundState >> Thinking ) ->
 *        ( TwinMockFsm >> CompoundState >> Answered )
 *        pp_Out2->CbAnswer(\"My answer!\");
 *    -91 ( OracleClientPsm >> Idle ) ->
 *        ( OracleClientPsm >> Asking )
 *        Ask( sAsk );
 *    102 ( OracleServerPsm >> Asked ) ->
 *        ( OracleServerPsm >> Idle )
 *        CbReply( \"This is answer of '\" + MyAsk + \"' !\" );
 *    120 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbQuestion(sQuestion);
 *    121 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbAnswer(sAnswer);
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;

namespace Twins
{
  public partial class Twins
  {
    static void ArgsHandle( string[] args )
    {
      for ( int i=0; i<args.Length; i++ )
      {
        char [] ca = args[ i ].ToCharArray();
        if ( ( ca.Length >= 2 ) && ( ca[ 0 ] == '-' ) )
        {
          switch ( ca[1] )
          {
          case 'l' :
            if ( ( ca.Length >= 4 ) && ( ca[ 2 ] == '=' ) )
            {
              int ll = Convert.ToInt32( args[ i ].Substring( 3 ) );
              Tsm.SetLogLevel( ll );
            }
            break;
          case 'C' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogConsole( ca[ 2 ] == '+' );
            }
            break;
          case 'L' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogFile( ca[ 2 ] == '+' );
            }
            break;
          case 'S' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetSeqFile( ca[ 2 ] == '+' );
            }
            break;
          }
        }
      }
    }

    static void Main( string[] args )
    {
      ArgsHandle( args );
      try
      {
        TsmSystem ts = new TsmSystem( null );
        ts.Activate();
        ts.Execute();
        ts.Deactivate();
      }
      catch ( Exception exc )
      {
        Tsm.Log( "*** TsmSystem Exception ***" );
        Tsm.Log( exc.Message );
        Tsm.Log( exc.StackTrace );
      }
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState )
  public class Ini_0058_0059 : TsmPseudo
  {
    public Ini_0058_0059( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 79, "( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 79; // TRLS ( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79: // UP: ( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
  public class Ini_0061_0062 : TsmPseudo
  {
    public Ini_0061_0062( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 67, "( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 67; // TRLS ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 67: // UP: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState )
  public class Fin_0061_0063 : TsmFinal
  {
    public Fin_0061_0063( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0061_0071( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0061_0071( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState )
  public class Cho_0061_0064 : TsmPseudo
  {
    public Cho_0061_0064( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 69, "( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )" );
      mTransitions[ 1 ] = new TsmTransition( 71, "( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( ((Cla_0051_0053)oHandler.Owner).Guard_1003() )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 69; // TRLS ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 71; // TRLS ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0061_0070( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69: // UP: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )
        bHigher = true;
        break;
      case 71: // UP: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )
        bHigher = true;
        break;
      case 70:
        Tra_0061_0070( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle )
  public class Lea_0061_0065 : TsmLeaf
  {
    public Lea_0061_0065( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 70, "( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )" );
    }

    public void Tra_0061_0067( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 70; // TRLS ( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0061_0068( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 67:
        Tra_0061_0067( oHandler );
        break;
      case 70: // UP: ( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 68:
        Tra_0061_0068( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking )
  public class Lea_0061_0066 : TsmLeaf
  {
    public Lea_0061_0066( TsmBase oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 68, "( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle ) : rp_In->CbAnswer" );
    }

    public void Tra_0061_0069( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_In___CbAnswer( String sAnswer, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 68; // rp_In.CbAnswer
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 54:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 54: // Port rp_In
        switch ( oHandler.Trigger.Command )
        {
        case 3: // rp_In___CbAnswer
          {
            TsmTrigger_ICbTwin___CbAnswer lTrigger = (TsmTrigger_ICbTwin___CbAnswer) oHandler.Trigger;

            rp_In___CbAnswer( lTrigger.sAnswer, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0061_0069( oHandler );
        break;
      case 68: // UP: ( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
  public class Reg_0060_0061 : TsmRegion
  {
    private Ini_0061_0062 oIni_0061_0062; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
    private Fin_0061_0063 oFin_0061_0063; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState )
    private Cho_0061_0064 oCho_0061_0064; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState )
    private Lea_0061_0065 oLea_0061_0065; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle )
    private Lea_0061_0066 oLea_0061_0066; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking )

    public Reg_0060_0061( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0061_0062 = new Ini_0061_0062( this );
      oFin_0061_0063 = new Fin_0061_0063( this );
      oCho_0061_0064 = new Cho_0061_0064( this );
      oLea_0061_0065 = new Lea_0061_0065( this );
      oLea_0061_0066 = new Lea_0061_0066( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0061_0062;
      mStates[ 1 ] = oFin_0061_0063;
      mStates[ 2 ] = oCho_0061_0064;
      mStates[ 3 ] = oLea_0061_0065;
      mStates[ 4 ] = oLea_0061_0066;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0061_0062.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )
    public void Tra_0061_0067( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1002( oHandler );
      mCurrentState = oLea_0061_0065; // At: ( ActorFsm >> CompoundState >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )
    public void Tra_0061_0069( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1004( oHandler );
      mCurrentState = oLea_0061_0066; // At: ( ActorFsm >> CompoundState >> Asking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )
    public void Tra_0061_0071( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1005( oHandler );
      mCurrentState = oFin_0061_0063; // At: ( ActorFsm >> CompoundState >> FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )
    public void Tra_0061_0070( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1006( oHandler );
      mCurrentState = oCho_0061_0064; // At: ( ActorFsm >> CompoundState >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle )
    public void Tra_0061_0068( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1015( oHandler );
      mCurrentState = oLea_0061_0065; // At: ( ActorFsm >> CompoundState >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 54:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 67:
        Tra_0061_0067( oHandler );
        break;
      case 69:
        Tra_0061_0069( oHandler );
        break;
      case 71:
        Tra_0061_0071( oHandler );
        break;
      case 70:
        Tra_0061_0070( oHandler );
        break;
      case 68:
        Tra_0061_0068( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
  public class Ini_0072_0073 : TsmPseudo
  {
    public Ini_0072_0073( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 76, "( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 76; // TRLS ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76: // UP: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered )
  public class Lea_0072_0074 : TsmLeaf
  {
    public Lea_0072_0074( TsmBase oParent )
    {
      TsmName = "Answered";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 77, "( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking ) : rp_In->CbQuestion" );
    }

    public void Tra_0072_0076( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_In___CbQuestion( String sQuestion, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 77; // rp_In.CbQuestion
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0072_0078( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 54:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 54: // Port rp_In
        switch ( oHandler.Trigger.Command )
        {
        case 2: // rp_In___CbQuestion
          {
            TsmTrigger_ICbTwin___CbQuestion lTrigger = (TsmTrigger_ICbTwin___CbQuestion) oHandler.Trigger;

            rp_In___CbQuestion( lTrigger.sQuestion, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76:
        Tra_0072_0076( oHandler );
        break;
      case 77: // UP: ( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking )
        bHigher = true;
        break;
      case 78:
        Tra_0072_0078( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking )
  public class Lea_0072_0075 : TsmLeaf
  {
    public Lea_0072_0075( TsmBase oParent )
    {
      TsmName = "Thinking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 78, "( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered ) : rp_Oracle->CbReply" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0072_0077( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_Oracle___CbReply( String sReply, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 78; // rp_Oracle.CbReply
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 56:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 56: // Port rp_Oracle
        switch ( oHandler.Trigger.Command )
        {
        case 4: // rp_Oracle___CbReply
          {
            TsmTrigger_ICbOracle___CbReply lTrigger = (TsmTrigger_ICbOracle___CbReply) oHandler.Trigger;

            rp_Oracle___CbReply( lTrigger.sReply, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 77:
        Tra_0072_0077( oHandler );
        break;
      case 78: // UP: ( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
  public class Reg_0060_0072 : TsmRegion
  {
    private Ini_0072_0073 oIni_0072_0073; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
    private Lea_0072_0074 oLea_0072_0074; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered )
    private Lea_0072_0075 oLea_0072_0075; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking )

    public Reg_0060_0072( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0072_0073 = new Ini_0072_0073( this );
      oLea_0072_0074 = new Lea_0072_0074( this );
      oLea_0072_0075 = new Lea_0072_0075( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0072_0073;
      mStates[ 1 ] = oLea_0072_0074;
      mStates[ 2 ] = oLea_0072_0075;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0072_0073.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )
    public void Tra_0072_0076( TsmHandler oHandler )
    {
      mCurrentState = oLea_0072_0074; // At: ( ActorFsm >> CompoundState >> Answered )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking )
    public void Tra_0072_0077( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1014( oHandler );
      mCurrentState = oLea_0072_0075; // At: ( ActorFsm >> CompoundState >> Thinking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered )
    public void Tra_0072_0078( TsmHandler oHandler )
    {
      ((Cla_0051_0053)oHandler.Owner).Function_1016( oHandler );
      mCurrentState = oLea_0072_0074; // At: ( ActorFsm >> CompoundState >> Answered )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 54:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 54
      case 56:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76:
        Tra_0072_0076( oHandler );
        break;
      case 77:
        Tra_0072_0077( oHandler );
        break;
      case 78:
        Tra_0072_0078( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState )
  public class Com_0058_0060 : TsmCompound
  {
    private Reg_0060_0061 oReg_0060_0061; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
    private Reg_0060_0072 oReg_0060_0072; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)

    public Com_0058_0060( TsmBase oParent )
    {
      TsmName = "CS_60";
      TsmParent = oParent;
      oReg_0060_0061 = new Reg_0060_0061( this );
      oReg_0060_0072 = new Reg_0060_0072( this );
      mRegions.Add( oReg_0060_0061 );
      mRegions.Add( oReg_0060_0072 );
      mNrTransitions = 0;
    }

    public void Tra_0058_0079( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0058_0079( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >)
  public class Reg_0057_0058 : TsmRegion
  {
    private Ini_0058_0059 oIni_0058_0059; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState )
    private Com_0058_0060 oCom_0058_0060; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState )

    public Reg_0057_0058( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0058_0059 = new Ini_0058_0059( this );
      oCom_0058_0060 = new Com_0058_0060( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0058_0059;
      mStates[ 1 ] = oCom_0058_0060;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0058_0059.ExecuteHandler( oHandler );
    }

     // At: ( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )
    public void Tra_0058_0079( TsmHandler oHandler )
    {
      mCurrentState = oCom_0058_0060; // At: ( ActorFsm >> CompoundState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 54:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 54
      case 56:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0058_0079( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm )
  public class Fsm_0053_0057 : TsmFsm
  {
    private Reg_0057_0058 oReg_0057_0058; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >)

    public Fsm_0053_0057( TsmBase oParent )
    {
      TsmName = "ActorFsm";
      TsmParent = oParent;
      oReg_0057_0058 = new Reg_0057_0058( this );
      mRegions.Add( oReg_0057_0058 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )
  public class Cla_0051_0053 : TsmClass
  {
    private Fsm_0053_0057 oFsm_0053_0057; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm )
    private TsmIPort_ICbTwin TsmPI__rp_In; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In )
    private TsmIPort_ICbTwin pp_Out; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > pp_Out )
    private TsmIPort_IOracle rp_Oracle; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
    private TsmIPort_ICbOracle TsmPI__rp_Oracle; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
    private TsmPCPort mPCMessager;
    private int MaxNumQuestion = 10;
    private int NumQuestion;

    public Cla_0051_0053( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0053_0057 = new Fsm_0053_0057( this );
      TsmPI__rp_In = new TsmIPort_ICbTwin( this );
      TsmPI__rp_Oracle = new TsmIPort_ICbOracle( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0053_0057;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "rp_In" :
        return TsmPI__rp_In;
      case "rp_Oracle" :
        return TsmPI__rp_Oracle;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_Out" :
        pp_Out = (TsmIPort_ICbTwin) oProvidedInterface;
        pp_Out.Source = this;
        return;
      case "rp_Oracle" :
        rp_Oracle = (TsmIPort_IOracle) oProvidedInterface;
        rp_Oracle.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0053_0057.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )
    public void Function_1002( TsmHandler oHandler )
    {
      NumQuestion=0;
    }

    public bool Guard_1003()
    {
      return NumQuestion<=MaxNumQuestion;
    }

     // ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )
    public void Function_1004( TsmHandler oHandler )
    {
      string s = "My question '"+NumQuestion+"' ?";
      pp_Out.CbQuestion(s);
    }

     // ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )
    public void Function_1005( TsmHandler oHandler )
    {
      TsmSupervisor.Abandon();
    }

     // ( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )
    public void Function_1006( TsmHandler oHandler )
    {
      NumQuestion++;
    }

     // ( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking )
    public void Function_1014( TsmHandler oHandler )
    {
      TsmTrigger_ICbTwin___CbQuestion lTrigger = (TsmTrigger_ICbTwin___CbQuestion) oHandler.Trigger;
      String sQuestion = lTrigger.sQuestion;

      rp_Oracle.Ask(sQuestion);
    }

     // ( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle )
    public void Function_1015( TsmHandler oHandler )
    {
      TsmTrigger_ICbTwin___CbAnswer lTrigger = (TsmTrigger_ICbTwin___CbAnswer) oHandler.Trigger;
      String sAnswer = lTrigger.sAnswer;

      string s = "Received answer: "+sAnswer;
      Tsm.Log( s );
    }

     // ( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered )
    public void Function_1016( TsmHandler oHandler )
    {
      TsmTrigger_ICbOracle___CbReply lTrigger = (TsmTrigger_ICbOracle___CbReply) oHandler.Trigger;
      String sReply = lTrigger.sReply;

      pp_Out.CbAnswer(sReply);
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__rp_In.PortId = 54;
      TsmPI__rp_In.Messager = mPCMessager;
      TsmPI__rp_Oracle.PortId = 56;
      TsmPI__rp_Oracle.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0053_0057.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Twin > ActorComponent )
  public class Com_0011_0051 : TsmPComponent
  {
    private Cla_0051_0053 Actor; // ( Xmi > Data > Repository > Twin > ActorComponent > Actor )

    public Com_0011_0051( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Actor = new Cla_0051_0053( this, "Actor" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = Actor;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "In" :
        return Actor.GetProvidedInterface( "rp_In" );
      case "rp_Oracle" :
        return Actor.GetProvidedInterface( "rp_Oracle" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "In" :
        Actor.SetRequiredInterface( "rp_In", oProvidedInterface );
        return;
      case "Out" :
        Actor.SetRequiredInterface( "pp_Out", oProvidedInterface );
        return;
      case "rp_Oracle" :
        Actor.SetRequiredInterface( "rp_Oracle", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState )
  public class Ini_0017_0018 : TsmPseudo
  {
    public Ini_0017_0018( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 21, "( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 21; // TRLS ( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 21: // UP: ( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle )
  public class Lea_0017_0019 : TsmLeaf
  {
    public Lea_0017_0019( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 22, "( OracleFsm >> Idle ) => ( OracleFsm >> Asked ) : Pythia->Ask" );
    }

    public void Tra_0017_0021( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0017_0023( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Pythia___Ask( String sAsk, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 22; // Pythia.Ask
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 15:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 15: // Port Pythia
        switch ( oHandler.Trigger.Command )
        {
        case 1: // Pythia___Ask
          {
            TsmTrigger_IOracle___Ask lTrigger = (TsmTrigger_IOracle___Ask) oHandler.Trigger;

            Pythia___Ask( lTrigger.sAsk, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 21:
        Tra_0017_0021( oHandler );
        break;
      case 23:
        Tra_0017_0023( oHandler );
        break;
      case 22: // UP: ( OracleFsm >> Idle ) => ( OracleFsm >> Asked )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked )
  public class Lea_0017_0020 : TsmLeaf
  {
    public Lea_0017_0020( TsmBase oParent )
    {
      TsmName = "Asked";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 23, "( OracleFsm >> Asked ) => ( OracleFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 23; // TRLS ( OracleFsm >> Asked ) => ( OracleFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0017_0022( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 23: // UP: ( OracleFsm >> Asked ) => ( OracleFsm >> Idle )
        bHigher = true;
        break;
      case 22:
        Tra_0017_0022( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >)
  public class Reg_0016_0017 : TsmRegion
  {
    private Ini_0017_0018 oIni_0017_0018; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState )
    private Lea_0017_0019 oLea_0017_0019; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle )
    private Lea_0017_0020 oLea_0017_0020; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked )

    public Reg_0016_0017( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0017_0018 = new Ini_0017_0018( this );
      oLea_0017_0019 = new Lea_0017_0019( this );
      oLea_0017_0020 = new Lea_0017_0020( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0017_0018;
      mStates[ 1 ] = oLea_0017_0019;
      mStates[ 2 ] = oLea_0017_0020;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0017_0018.ExecuteHandler( oHandler );
    }

     // At: ( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )
    public void Tra_0017_0021( TsmHandler oHandler )
    {
      mCurrentState = oLea_0017_0019; // At: ( OracleFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleFsm >> Asked ) => ( OracleFsm >> Idle )
    public void Tra_0017_0023( TsmHandler oHandler )
    {
      ((Cla_0012_0014)oHandler.Owner).Function_1001( oHandler );
      mCurrentState = oLea_0017_0019; // At: ( OracleFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleFsm >> Idle ) => ( OracleFsm >> Asked )
    public void Tra_0017_0022( TsmHandler oHandler )
    {
      ((Cla_0012_0014)oHandler.Owner).Function_1013( oHandler );
      mCurrentState = oLea_0017_0020; // At: ( OracleFsm >> Asked )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 15:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 21:
        Tra_0017_0021( oHandler );
        break;
      case 23:
        Tra_0017_0023( oHandler );
        break;
      case 22:
        Tra_0017_0022( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm )
  public class Fsm_0014_0016 : TsmFsm
  {
    private Reg_0016_0017 oReg_0016_0017; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >)

    public Fsm_0014_0016( TsmBase oParent )
    {
      TsmName = "OracleFsm";
      TsmParent = oParent;
      oReg_0016_0017 = new Reg_0016_0017( this );
      mRegions.Add( oReg_0016_0017 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )
  public class Cla_0012_0014 : TsmClass
  {
    private Fsm_0014_0016 oFsm_0014_0016; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm )
    private TsmIPort_IOracle TsmPI__Pythia; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
    private TsmIPort_ICbOracle Pythia; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
    private TsmPSPort mPSMessager;
    private String MyAsk;

    public Cla_0012_0014( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0014_0016 = new Fsm_0014_0016( this );
      TsmPI__Pythia = new TsmIPort_IOracle( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0014_0016;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Pythia" :
        return TsmPI__Pythia;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Pythia" :
        Pythia = (TsmIPort_ICbOracle) oProvidedInterface;
        Pythia.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0014_0016.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( OracleFsm >> Asked ) => ( OracleFsm >> Idle )
    public void Function_1001( TsmHandler oHandler )
    {
      Pythia.CbReply( "This is answer of '" + MyAsk + "' !" );
    }

     // ( OracleFsm >> Idle ) => ( OracleFsm >> Asked )
    public void Function_1013( TsmHandler oHandler )
    {
      TsmTrigger_IOracle___Ask lTrigger = (TsmTrigger_IOracle___Ask) oHandler.Trigger;
      String sAsk = lTrigger.sAsk;

      MyAsk = sAsk;
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Pythia.PortId = 15;
      TsmPI__Pythia.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0014_0016.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Twin > OracleComponent )
  public class Com_0011_0012 : TsmPComponent
  {
    private Cla_0012_0014 Delphi; // ( Xmi > Data > Repository > Twin > OracleComponent > Delphi )

    public Com_0011_0012( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Delphi = new Cla_0012_0014( this, "Delphi" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = Delphi;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_Oracle" :
        return Delphi.GetProvidedInterface( "Pythia" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_Oracle" :
        Delphi.SetRequiredInterface( "Pythia", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinComponent )
  public class Com_0011_0048 : TsmAComponent
  {
    private Com_0011_0051 ActorComp; // ( Xmi > Data > Repository > Twin > TwinComponent > ActorComp )
    private Com_0011_0012 OracleComp; // ( Xmi > Data > Repository > Twin > TwinComponent > OracleComp )
    private TsmIPort_ICbTwin TsmPI__In; // ( Xmi > Data > Repository > Twin > TwinComponent > In )
    private TsmACPort TsmMr__In;

    public Com_0011_0048( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      ActorComp = new Com_0011_0051( this, "ActorComp" );
      OracleComp = new Com_0011_0012( this, "OracleComp" );
      mNrComponents = 2;
      mComponents = new TsmComponent[ 2 ];
      mComponents[ 0 ] = ActorComp;
      mComponents[ 1 ] = OracleComp;
      TsmPI__In = new TsmIPort_ICbTwin( this );
      TsmMr__In = new TsmACPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "In" :
        return TsmPI__In;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "In" :
        ActorComp.SetRequiredInterface( "In", oProvidedInterface );
        return;
      case "Out" :
        ActorComp.SetRequiredInterface( "Out", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinComponent )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__In.Thread = Thread;
      TsmPI__In.Messager = TsmMr__In;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = ActorComp.GetProvidedInterface( "In" );
      TsmPI__In.PortId = ClassPort.PortId;
      TsmMr__In.Target = ClassPort.Messager.Target;
      DoAssembly( ActorComp, "rp_Oracle", OracleComp, "pp_Oracle" );
      DoAssembly( OracleComp, "pp_Oracle", ActorComp, "rp_Oracle" );
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState )
  public class Ini_0030_0031 : TsmPseudo
  {
    public Ini_0030_0031( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 47, "( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 47; // TRLS ( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 47: // UP: ( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
  public class Ini_0033_0034 : TsmPseudo
  {
    public Ini_0033_0034( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 37, "( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 37; // TRLS ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37: // UP: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle )
  public class Lea_0033_0035 : TsmLeaf
  {
    int [] aNatives = { 38 };

    public Lea_0033_0035( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 38, "( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )" );
    }

    public void Tra_0033_0037( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0033_0039( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 38:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 38: // Native: ( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )
          TsmRecorder.AddNative( "( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking ) # pp_Out2.CbQuestion(\"My question?\");" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 38;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37:
        Tra_0033_0037( oHandler );
        break;
      case 38: // UP: ( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 39:
        Tra_0033_0039( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking )
  public class Lea_0033_0036 : TsmLeaf
  {
    public Lea_0033_0036( TsmBase oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 39, "( TwinMockFsm >> CompoundState >> Asking ) => ( TwinMockFsm >> CompoundState >> Idle ) : rp_In2->CbAnswer" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0033_0038( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_In2___CbAnswer( String sAnswer, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 39; // rp_In2.CbAnswer
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 27:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 27: // Port rp_In2
        switch ( oHandler.Trigger.Command )
        {
        case 3: // rp_In2___CbAnswer
          {
            TsmTrigger_ICbTwin___CbAnswer lTrigger = (TsmTrigger_ICbTwin___CbAnswer) oHandler.Trigger;

            rp_In2___CbAnswer( lTrigger.sAnswer, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 38:
        Tra_0033_0038( oHandler );
        break;
      case 39: // UP: ( TwinMockFsm >> CompoundState >> Asking ) => ( TwinMockFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
  public class Reg_0032_0033 : TsmRegion
  {
    private Ini_0033_0034 oIni_0033_0034; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
    private Lea_0033_0035 oLea_0033_0035; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle )
    private Lea_0033_0036 oLea_0033_0036; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking )

    public Reg_0032_0033( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0033_0034 = new Ini_0033_0034( this );
      oLea_0033_0035 = new Lea_0033_0035( this );
      oLea_0033_0036 = new Lea_0033_0036( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0033_0034;
      mStates[ 1 ] = oLea_0033_0035;
      mStates[ 2 ] = oLea_0033_0036;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0033_0034.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )
    public void Tra_0033_0037( TsmHandler oHandler )
    {
      mCurrentState = oLea_0033_0035; // At: ( TwinMockFsm >> CompoundState >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )
    public void Tra_0033_0038( TsmHandler oHandler )
    {
      ((Cla_0024_0026)oHandler.Owner).Function_1007( oHandler );
      mCurrentState = oLea_0033_0036; // At: ( TwinMockFsm >> CompoundState >> Asking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> Asking ) => ( TwinMockFsm >> CompoundState >> Idle )
    public void Tra_0033_0039( TsmHandler oHandler )
    {
      mCurrentState = oLea_0033_0035; // At: ( TwinMockFsm >> CompoundState >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 38:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 27:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37:
        Tra_0033_0037( oHandler );
        break;
      case 38:
        Tra_0033_0038( oHandler );
        break;
      case 39:
        Tra_0033_0039( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
  public class Ini_0040_0041 : TsmPseudo
  {
    public Ini_0040_0041( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 44, "( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 44; // TRLS ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 44: // UP: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered )
  public class Lea_0040_0042 : TsmLeaf
  {
    public Lea_0040_0042( TsmBase oParent )
    {
      TsmName = "Answered";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 45, "( TwinMockFsm >> CompoundState >> Answered ) => ( TwinMockFsm >> CompoundState >> Thinking ) : rp_In2->CbQuestion" );
    }

    public void Tra_0040_0044( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0040_0046( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_In2___CbQuestion( String sQuestion, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 45; // rp_In2.CbQuestion
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 27:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 27: // Port rp_In2
        switch ( oHandler.Trigger.Command )
        {
        case 2: // rp_In2___CbQuestion
          {
            TsmTrigger_ICbTwin___CbQuestion lTrigger = (TsmTrigger_ICbTwin___CbQuestion) oHandler.Trigger;

            rp_In2___CbQuestion( lTrigger.sQuestion, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 44:
        Tra_0040_0044( oHandler );
        break;
      case 46:
        Tra_0040_0046( oHandler );
        break;
      case 45: // UP: ( TwinMockFsm >> CompoundState >> Answered ) => ( TwinMockFsm >> CompoundState >> Thinking )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking )
  public class Lea_0040_0043 : TsmLeaf
  {
    int [] aNatives = { 46 };

    public Lea_0040_0043( TsmBase oParent )
    {
      TsmName = "Thinking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 46, "( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0040_0045( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 46:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 46: // Native: ( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )
          TsmRecorder.AddNative( "( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered ) # pp_Out2.CbAnswer(\"My answer!\");" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 46;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 46: // UP: ( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 45:
        Tra_0040_0045( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
  public class Reg_0032_0040 : TsmRegion
  {
    private Ini_0040_0041 oIni_0040_0041; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
    private Lea_0040_0042 oLea_0040_0042; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered )
    private Lea_0040_0043 oLea_0040_0043; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking )

    public Reg_0032_0040( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0040_0041 = new Ini_0040_0041( this );
      oLea_0040_0042 = new Lea_0040_0042( this );
      oLea_0040_0043 = new Lea_0040_0043( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0040_0041;
      mStates[ 1 ] = oLea_0040_0042;
      mStates[ 2 ] = oLea_0040_0043;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0040_0041.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )
    public void Tra_0040_0044( TsmHandler oHandler )
    {
      mCurrentState = oLea_0040_0042; // At: ( TwinMockFsm >> CompoundState >> Answered )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )
    public void Tra_0040_0046( TsmHandler oHandler )
    {
      ((Cla_0024_0026)oHandler.Owner).Function_1008( oHandler );
      mCurrentState = oLea_0040_0042; // At: ( TwinMockFsm >> CompoundState >> Answered )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> CompoundState >> Answered ) => ( TwinMockFsm >> CompoundState >> Thinking )
    public void Tra_0040_0045( TsmHandler oHandler )
    {
      mCurrentState = oLea_0040_0043; // At: ( TwinMockFsm >> CompoundState >> Thinking )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 46:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 27:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 44:
        Tra_0040_0044( oHandler );
        break;
      case 46:
        Tra_0040_0046( oHandler );
        break;
      case 45:
        Tra_0040_0045( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState )
  public class Com_0030_0032 : TsmCompound
  {
    private Reg_0032_0033 oReg_0032_0033; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
    private Reg_0032_0040 oReg_0032_0040; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)

    public Com_0030_0032( TsmBase oParent )
    {
      TsmName = "CS_32";
      TsmParent = oParent;
      oReg_0032_0033 = new Reg_0032_0033( this );
      oReg_0032_0040 = new Reg_0032_0040( this );
      mRegions.Add( oReg_0032_0033 );
      mRegions.Add( oReg_0032_0040 );
      mNrTransitions = 0;
    }

    public void Tra_0030_0047( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 47:
        Tra_0030_0047( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >)
  public class Reg_0029_0030 : TsmRegion
  {
    private Ini_0030_0031 oIni_0030_0031; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState )
    private Com_0030_0032 oCom_0030_0032; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState )

    public Reg_0029_0030( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0030_0031 = new Ini_0030_0031( this );
      oCom_0030_0032 = new Com_0030_0032( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0030_0031;
      mStates[ 1 ] = oCom_0030_0032;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0030_0031.ExecuteHandler( oHandler );
    }

     // At: ( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )
    public void Tra_0030_0047( TsmHandler oHandler )
    {
      mCurrentState = oCom_0030_0032; // At: ( TwinMockFsm >> CompoundState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 38:
          return TsmProspect.OK;
        case 46:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 27:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 47:
        Tra_0030_0047( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm )
  public class Fsm_0026_0029 : TsmFsm
  {
    private Reg_0029_0030 oReg_0029_0030; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >)

    public Fsm_0026_0029( TsmBase oParent )
    {
      TsmName = "TwinMockFsm";
      TsmParent = oParent;
      oReg_0029_0030 = new Reg_0029_0030( this );
      mRegions.Add( oReg_0029_0030 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )
  public class Cla_0024_0026 : TsmClass
  {
    private Fsm_0026_0029 oFsm_0026_0029; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm )
    private TsmIPort_ICbTwin TsmPI__rp_In2; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 )
    private TsmIPort_ICbTwin pp_Out2; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > pp_Out2 )
    private TsmPCPort mPCMessager;
    private String sQuestion;
    private String sAnswer;

    public Cla_0024_0026( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0026_0029 = new Fsm_0026_0029( this );
      TsmPI__rp_In2 = new TsmIPort_ICbTwin( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0026_0029;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "rp_In2" :
        return TsmPI__rp_In2;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_Out2" :
        pp_Out2 = (TsmIPort_ICbTwin) oProvidedInterface;
        pp_Out2.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0026_0029.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )
    public void Function_1007( TsmHandler oHandler )
    {
      pp_Out2.CbQuestion("My question?");
    }

     // ( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )
    public void Function_1008( TsmHandler oHandler )
    {
      pp_Out2.CbAnswer("My answer!");
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__rp_In2.PortId = 27;
      TsmPI__rp_In2.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0026_0029.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Twin > TwinMock )
  public class Com_0011_0024 : TsmAComponent
  {
    private Cla_0024_0026 Twin; // ( Xmi > Data > Repository > Twin > TwinMock > Twin )
    private TsmIPort_ICbTwin TsmPI__In2; // ( Xmi > Data > Repository > Twin > TwinMock > In2 )
    private TsmACPort TsmMr__In2;

    public Com_0011_0024( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Twin = new Cla_0024_0026( this, "Twin" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = Twin;
      TsmPI__In2 = new TsmIPort_ICbTwin( this );
      TsmMr__In2 = new TsmACPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "In2" :
        return TsmPI__In2;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "In2" :
        Twin.SetRequiredInterface( "rp_In2", oProvidedInterface );
        return;
      case "Out2" :
        Twin.SetRequiredInterface( "pp_Out2", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__In2.Thread = Thread;
      TsmPI__In2.Messager = TsmMr__In2;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = Twin.GetProvidedInterface( "rp_In2" );
      TsmPI__In2.PortId = ClassPort.PortId;
      TsmMr__In2.Target = ClassPort.Messager.Target;
    }
  }

   // ( Xmi > Data > Architecture > TwinsTest )
  public class Com_0002_0006 : TsmPComponent
  {
    private Com_0011_0024 Alice; // ( Xmi > Data > Architecture > TwinsTest > Alice )
    private Com_0011_0024 Bob; // ( Xmi > Data > Architecture > TwinsTest > Bob )

    public Com_0002_0006( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Alice = new Com_0011_0024( this, "Alice" );
      Bob = new Com_0011_0024( this, "Bob" );
      mNrComponents = 2;
      mComponents = new TsmComponent[ 2 ];
      mComponents[ 0 ] = Alice;
      mComponents[ 1 ] = Bob;
    }

    public override void TsmConnect( object oObject )
    {
      DoAssembly( Bob, "Out2", Alice, "In2" );
      DoAssembly( Alice, "Out2", Bob, "In2" );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  public class Pac_0002_0009 : TsmPackage
  {
    public Pac_0002_0009( TsmBase oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  public class Pac_0001_0002 : TsmPackage
  {
    public Pac_0001_0002( TsmBase oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Twin )
   ********************************************************************/

   // ( Xmi > Data > Repository > Twin )
  public class Pac_0010_0011 : TsmPackage
  {
    public Pac_0010_0011( TsmBase oParent )
    {
      TsmName = "Twin";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  public class Pac_0001_0010 : TsmPackage
  {
    public Pac_0001_0010( TsmBase oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  public class Pac_0001_0080 : TsmPackage
  {
    public Pac_0001_0080( TsmBase oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  }

  public interface ICbOracle
  {
    void CbReply( String sReply );
  }

  public class TsmTrigger_ICbOracle___CbReply : TsmTrigger
  {
    public String sReply;

    public TsmTrigger_ICbOracle___CbReply( String sReply )
      : base( 4 )
    {
      this.sReply = sReply;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > ICbOracle )
  public class TsmIPort_ICbOracle : TsmInterfacePort, ICbOracle
  {
    public TsmIPort_ICbOracle( TsmBase oParent )
    {
      TsmName = "ICbOracle";
      TsmParent = oParent;
    }

    public virtual void CbReply( String sReply )
    {
      TsmTrigger_ICbOracle___CbReply tt = new TsmTrigger_ICbOracle___CbReply( sReply );
      TsmRecorder.AddCall( "CbReply", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

  public interface IOracle
  {
    void Ask( String sAsk );
  }

  public class TsmTrigger_IOracle___Ask : TsmTrigger
  {
    public String sAsk;

    public TsmTrigger_IOracle___Ask( String sAsk )
      : base( 1 )
    {
      this.sAsk = sAsk;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > IOracle )
  public class TsmIPort_IOracle : TsmInterfacePort, IOracle
  {
    public TsmIPort_IOracle( TsmBase oParent )
    {
      TsmName = "IOracle";
      TsmParent = oParent;
    }

    public virtual void Ask( String sAsk )
    {
      TsmTrigger_IOracle___Ask tt = new TsmTrigger_IOracle___Ask( sAsk );
      TsmRecorder.AddCall( "Ask", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState )
  public class Ini_0086_0087 : TsmPseudo
  {
    public Ini_0086_0087( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 90, "( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 90; // TRLS ( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90: // UP: ( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle )
  public class Lea_0086_0088 : TsmLeaf
  {
    int [] aNatives = { -91 };

    public Lea_0086_0088( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 91, "( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )" );
    }

    public void Tra_0086_0090( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0086_0092( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 91: // Native: ( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )
          TsmRecorder.AddNative( "( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking ) # Ask( sAsk );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 91;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91: // UP: ( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking )
  public class Lea_0086_0089 : TsmLeaf
  {
    public Lea_0086_0089( TsmBase oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 92, "( OracleClientPsm >> Asking ) => ( OracleClientPsm >> Idle ) : CbReply" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0086_0091( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbReply( String sReply, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 92; // CbReply
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 84:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 84: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 4: // Port___CbReply
          {
            TsmTrigger_ICbOracle___CbReply lTrigger = (TsmTrigger_ICbOracle___CbReply) oHandler.Trigger;

            Port___CbReply( lTrigger.sReply, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92: // UP: ( OracleClientPsm >> Asking ) => ( OracleClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >)
  public class Reg_0085_0086 : TsmRegion
  {
    private Ini_0086_0087 oIni_0086_0087; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState )
    private Lea_0086_0088 oLea_0086_0088; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle )
    private Lea_0086_0089 oLea_0086_0089; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking )

    public Reg_0085_0086( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0086_0087 = new Ini_0086_0087( this );
      oLea_0086_0088 = new Lea_0086_0088( this );
      oLea_0086_0089 = new Lea_0086_0089( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0086_0087;
      mStates[ 1 ] = oLea_0086_0088;
      mStates[ 2 ] = oLea_0086_0089;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0086_0087.ExecuteHandler( oHandler );
    }

     // At: ( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )
    public void Tra_0086_0090( TsmHandler oHandler )
    {
      mCurrentState = oLea_0086_0088; // At: ( OracleClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )
    public void Tra_0086_0091( TsmHandler oHandler )
    {
      ((Cla_0082_0083)oHandler.Owner).Function_1009( oHandler );
      mCurrentState = oLea_0086_0089; // At: ( OracleClientPsm >> Asking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleClientPsm >> Asking ) => ( OracleClientPsm >> Idle )
    public void Tra_0086_0092( TsmHandler oHandler )
    {
      mCurrentState = oLea_0086_0088; // At: ( OracleClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 84:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm )
  public class Fsm_0083_0085 : TsmFsm
  {
    private Reg_0085_0086 oReg_0085_0086; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >)

    public Fsm_0083_0085( TsmBase oParent )
    {
      TsmName = "OracleClientPsm";
      TsmParent = oParent;
      oReg_0085_0086 = new Reg_0085_0086( this );
      mRegions.Add( oReg_0085_0086 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient )
  public class Cla_0082_0083 : TsmProtocolClass
  {
    private Fsm_0083_0085 oFsm_0083_0085; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm )
    private TsmIPort_IOracle Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
    private TsmIPort_ICbOracle TsmPI__Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
    private TsmPCPort mPCMessager;
    private String sAsk = "Question";

    public Cla_0082_0083( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0083_0085 = new Fsm_0083_0085( this );
      TsmPI__Port = new TsmIPort_ICbOracle( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0083_0085;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IOracle) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0083_0085.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )
    public void Function_1009( TsmHandler oHandler )
    {
      Port.Ask( sAsk );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 84;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0083_0085.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState )
  public class Ini_0096_0097 : TsmPseudo
  {
    public Ini_0096_0097( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 100, "( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 100; // TRLS ( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100: // UP: ( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle )
  public class Lea_0096_0098 : TsmLeaf
  {
    public Lea_0096_0098( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked ) : Ask" );
    }

    public void Tra_0096_0100( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0096_0102( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Ask( String sAsk, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 101; // Ask
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 94:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 94: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 1: // Port___Ask
          {
            TsmTrigger_IOracle___Ask lTrigger = (TsmTrigger_IOracle___Ask) oHandler.Trigger;

            Port___Ask( lTrigger.sAsk, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 101: // UP: ( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked )
  public class Lea_0096_0099 : TsmLeaf
  {
    int [] aNatives = { 102 };

    public Lea_0096_0099( TsmBase oParent )
    {
      TsmName = "Asked";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 102, "( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0096_0101( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 102: // Native: ( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )
          TsmRecorder.AddNative( "( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle ) # CbReply( \"This is answer of '\" + MyAsk + \"' !\" );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 102;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 102: // UP: ( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >)
  public class Reg_0095_0096 : TsmRegion
  {
    private Ini_0096_0097 oIni_0096_0097; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState )
    private Lea_0096_0098 oLea_0096_0098; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle )
    private Lea_0096_0099 oLea_0096_0099; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked )

    public Reg_0095_0096( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0096_0097 = new Ini_0096_0097( this );
      oLea_0096_0098 = new Lea_0096_0098( this );
      oLea_0096_0099 = new Lea_0096_0099( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0096_0097;
      mStates[ 1 ] = oLea_0096_0098;
      mStates[ 2 ] = oLea_0096_0099;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0096_0097.ExecuteHandler( oHandler );
    }

     // At: ( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )
    public void Tra_0096_0100( TsmHandler oHandler )
    {
      mCurrentState = oLea_0096_0098; // At: ( OracleServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )
    public void Tra_0096_0102( TsmHandler oHandler )
    {
      ((Cla_0082_0093)oHandler.Owner).Function_1010( oHandler );
      mCurrentState = oLea_0096_0098; // At: ( OracleServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked )
    public void Tra_0096_0101( TsmHandler oHandler )
    {
      ((Cla_0082_0093)oHandler.Owner).Function_1017( oHandler );
      mCurrentState = oLea_0096_0099; // At: ( OracleServerPsm >> Asked )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 94:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm )
  public class Fsm_0093_0095 : TsmFsm
  {
    private Reg_0095_0096 oReg_0095_0096; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >)

    public Fsm_0093_0095( TsmBase oParent )
    {
      TsmName = "OracleServerPsm";
      TsmParent = oParent;
      oReg_0095_0096 = new Reg_0095_0096( this );
      mRegions.Add( oReg_0095_0096 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer )
  public class Cla_0082_0093 : TsmProtocolClass
  {
    private Fsm_0093_0095 oFsm_0093_0095; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm )
    private TsmIPort_IOracle TsmPI__Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
    private TsmIPort_ICbOracle Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
    private TsmPSPort mPSMessager;
    private String MyAsk;

    public Cla_0082_0093( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0093_0095 = new Fsm_0093_0095( this );
      TsmPI__Port = new TsmIPort_IOracle( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0093_0095;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbOracle) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0093_0095.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )
    public void Function_1010( TsmHandler oHandler )
    {
      Port.CbReply( "This is answer of '" + MyAsk + "' !" );
    }

     // ( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked )
    public void Function_1017( TsmHandler oHandler )
    {
      TsmTrigger_IOracle___Ask lTrigger = (TsmTrigger_IOracle___Ask) oHandler.Trigger;
      String sAsk = lTrigger.sAsk;

      MyAsk = sAsk;
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 94;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0093_0095.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > OracleProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > OracleProtocol )
  public class Pac_0081_0082 : TsmPackage
  {
    public Pac_0081_0082( TsmBase oParent )
    {
      TsmName = "OracleProtocol";
      TsmParent = oParent;
    }
  }

  public interface ICbTwin
  {
    void CbQuestion( String sQuestion );
    void CbAnswer( String sAnswer );
  }

  public class TsmTrigger_ICbTwin___CbQuestion : TsmTrigger
  {
    public String sQuestion;

    public TsmTrigger_ICbTwin___CbQuestion( String sQuestion )
      : base( 2 )
    {
      this.sQuestion = sQuestion;
    }
  }

  public class TsmTrigger_ICbTwin___CbAnswer : TsmTrigger
  {
    public String sAnswer;

    public TsmTrigger_ICbTwin___CbAnswer( String sAnswer )
      : base( 3 )
    {
      this.sAnswer = sAnswer;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > ICbTwin )
  public class TsmIPort_ICbTwin : TsmInterfacePort, ICbTwin
  {
    public TsmIPort_ICbTwin( TsmBase oParent )
    {
      TsmName = "ICbTwin";
      TsmParent = oParent;
    }

    public virtual void CbQuestion( String sQuestion )
    {
      TsmTrigger_ICbTwin___CbQuestion tt = new TsmTrigger_ICbTwin___CbQuestion( sQuestion );
      TsmRecorder.AddCall( "CbQuestion", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbAnswer( String sAnswer )
    {
      TsmTrigger_ICbTwin___CbAnswer tt = new TsmTrigger_ICbTwin___CbAnswer( sAnswer );
      TsmRecorder.AddCall( "CbAnswer", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState )
  public class Ini_0107_0108 : TsmPseudo
  {
    public Ini_0107_0108( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 110, "( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 110; // TRLS ( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 110: // UP: ( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle )
  public class Lea_0107_0109 : TsmLeaf
  {
    public Lea_0107_0109( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 111, "( TwinClientPsm >> Idle ) => ( TwinClientPsm >> Idle ) : CbQuestion" );
      mTransitions[ 1 ] = new TsmTransition( 112, "( TwinClientPsm >> Idle ) => ( TwinClientPsm >> Idle ) : CbAnswer" );
    }

    public void Tra_0107_0110( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0107_0111( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___CbQuestion( String sQuestion, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 111; // CbQuestion
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0107_0112( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___CbAnswer( String sAnswer, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 112; // CbAnswer
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 105:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 105: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 2: // Port___CbQuestion
          {
            TsmTrigger_ICbTwin___CbQuestion lTrigger = (TsmTrigger_ICbTwin___CbQuestion) oHandler.Trigger;

            Port___CbQuestion( lTrigger.sQuestion, oHandler );
          }
          break;
        case 3: // Port___CbAnswer
          {
            TsmTrigger_ICbTwin___CbAnswer lTrigger = (TsmTrigger_ICbTwin___CbAnswer) oHandler.Trigger;

            Port___CbAnswer( lTrigger.sAnswer, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 110:
        Tra_0107_0110( oHandler );
        break;
      case 111:
        Tra_0107_0111( oHandler );
        break;
      case 112:
        Tra_0107_0112( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >)
  public class Reg_0106_0107 : TsmRegion
  {
    private Ini_0107_0108 oIni_0107_0108; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState )
    private Lea_0107_0109 oLea_0107_0109; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle )

    public Reg_0106_0107( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0107_0108 = new Ini_0107_0108( this );
      oLea_0107_0109 = new Lea_0107_0109( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0107_0108;
      mStates[ 1 ] = oLea_0107_0109;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0107_0108.ExecuteHandler( oHandler );
    }

     // At: ( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )
    public void Tra_0107_0110( TsmHandler oHandler )
    {
      mCurrentState = oLea_0107_0109; // At: ( TwinClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 105:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 110:
        Tra_0107_0110( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm )
  public class Fsm_0104_0106 : TsmFsm
  {
    private Reg_0106_0107 oReg_0106_0107; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >)

    public Fsm_0104_0106( TsmBase oParent )
    {
      TsmName = "TwinClientPsm";
      TsmParent = oParent;
      oReg_0106_0107 = new Reg_0106_0107( this );
      mRegions.Add( oReg_0106_0107 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient )
  public class Cla_0103_0104 : TsmProtocolClass
  {
    private Fsm_0104_0106 oFsm_0104_0106; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm )
    private TsmIPort_ICbTwin TsmPI__Port; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port )
    private TsmPCPort mPCMessager;

    public Cla_0103_0104( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0104_0106 = new Fsm_0104_0106( this );
      TsmPI__Port = new TsmIPort_ICbTwin( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0104_0106;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TwinProtocol > TwinClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0104_0106.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 105;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0104_0106.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState )
  public class Ini_0116_0117 : TsmPseudo
  {
    public Ini_0116_0117( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 119, "( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 119; // TRLS ( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 119: // UP: ( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle )
  public class Lea_0116_0118 : TsmLeaf
  {
    int [] aNatives = { 120, 121 };

    public Lea_0116_0118( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 120, "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 121, "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )" );
    }

    public void Tra_0116_0119( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0116_0120( TsmHandler oHandler )
    {
      AtExit( oHandler );
      ((Cla_0103_0113)oHandler.Owner).Function_1011( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Tra_0116_0121( TsmHandler oHandler )
    {
      AtExit( oHandler );
      ((Cla_0103_0113)oHandler.Owner).Function_1012( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 120:
          return TsmProspect.OK;
        case 121:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 120: // Native: ( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )
          TsmRecorder.AddNative( "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle ) # CbQuestion(sQuestion);" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 120;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 121: // Native: ( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )
          TsmRecorder.AddNative( "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle ) # CbAnswer(sAnswer);" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 121;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 119:
        Tra_0116_0119( oHandler );
        break;
      case 120:
        Tra_0116_0120( oHandler );
        break;
      case 121:
        Tra_0116_0121( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >)
  public class Reg_0115_0116 : TsmRegion
  {
    private Ini_0116_0117 oIni_0116_0117; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState )
    private Lea_0116_0118 oLea_0116_0118; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle )

    public Reg_0115_0116( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0116_0117 = new Ini_0116_0117( this );
      oLea_0116_0118 = new Lea_0116_0118( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0116_0117;
      mStates[ 1 ] = oLea_0116_0118;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0116_0117.ExecuteHandler( oHandler );
    }

     // At: ( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )
    public void Tra_0116_0119( TsmHandler oHandler )
    {
      mCurrentState = oLea_0116_0118; // At: ( TwinServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 120:
          return TsmProspect.OK;
        case 121:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 119:
        Tra_0116_0119( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm )
  public class Fsm_0113_0115 : TsmFsm
  {
    private Reg_0115_0116 oReg_0115_0116; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >)

    public Fsm_0113_0115( TsmBase oParent )
    {
      TsmName = "TwinServerPsm";
      TsmParent = oParent;
      oReg_0115_0116 = new Reg_0115_0116( this );
      mRegions.Add( oReg_0115_0116 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer )
  public class Cla_0103_0113 : TsmProtocolClass
  {
    private Fsm_0113_0115 oFsm_0113_0115; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm )
    private TsmIPort_ICbTwin Port; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > Port )
    private String sQuestion = "The Question";
    private String sAnswer = "The Answer";

    public Cla_0103_0113( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0113_0115 = new Fsm_0113_0115( this );
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0113_0115;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbTwin) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TwinProtocol > TwinServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0113_0115.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )
    public void Function_1011( TsmHandler oHandler )
    {
      Port.CbQuestion(sQuestion);
    }

     // ( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )
    public void Function_1012( TsmHandler oHandler )
    {
      Port.CbAnswer(sAnswer);
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0113_0115.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > TwinProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > TwinProtocol )
  public class Pac_0081_0103 : TsmPackage
  {
    public Pac_0081_0103( TsmBase oParent )
    {
      TsmName = "TwinProtocol";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  public class Pac_0001_0081 : TsmPackage
  {
    public Pac_0001_0081( TsmBase oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  }

   // ( Xmi )
  public class TsmSystem : TsmExecComponent
  {
    private Com_0002_0006 TwinsTest; // ( Xmi > Data > Architecture > TwinsTest )

    public TsmSystem( TsmBase oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent[ 1 ];
      TwinsTest = new Com_0002_0006( null, "TwinsTest" );
      mComponents[ 0 ] = TwinsTest;
    }
  }
}
